//
//  wizard.js
//
//  $Id: wizard.js,v 1.6 2003/07/28 13:23:50 source Exp $
//
//  Generic Javascript functions for Wizard pages
//
//  (C)Copyright 2003 OpenLink Software.
//  All Rights Reserved.
//
//  The copyright above and this notice must be preserved in all
//  copies of this source code.  The copyright above does not
//  evidence any actual or intended publication of this source code.
//
//  This is unpublished proprietary trade secret of OpenLink Software.
//  This source code may not be copied, disclosed, distributed, demonstrated
//  or licensed except as authorized by OpenLink Software.
//

//DEBUG
//alert ("Debug: Loading generic JAVASCRIPT functions");
//DEBUG


// ----------------------------------------------------------------------
//  Generic functions
// ----------------------------------------------------------------------
function OplGetElement(elOrId) {
  var elm = null;

  if (typeof elOrId != "string") {
    // already an element
    elm = elOrId;
  } else if (document.getElementById) {
    // browser implements part of W3C DOM HTML
    // Gecko, Internet Explorer 5+, Opera 5+
    elm = document.getElementById(elOrId);
  } else if (document.all) {
    // Internet Explorer 4 or Opera with IE user agent
    elm = document.all[elOrId];
  } else if (document.layers) {
    // Navigator 4
    elm = document.layers[elOrId];
  }

  return elm
}


function findLabelFor (elOrId) {
  var el = OplGetElement (elOrId);
  var labels = document.getElementsByTagName('LABEL');
  var found = false;

  for (var l = 0; l < labels.length; l++)
    if (found = el.id == labels[l].htmlFor)
    break;

  if (found)
    return labels[l];
  else
    return null;
}


function getRealLeft(el) {
  xPos = el.offsetLeft;
  tempEl = el.offsetParent;
  while (tempEl != null) {
    xPos += tempEl.offsetLeft;
    tempEl = tempEl.offsetParent;
  }
  return xPos;
}


function getRealTop(el) {
  yPos = el.offsetTop;
  tempEl = el.offsetParent;
  while (tempEl != null) {
    yPos += tempEl.offsetTop;
    tempEl = tempEl.offsetParent;
  }
  return yPos;
}


function getFirstField(form) {
  for (var e = 0; e < form.elements.length; e++) {
    if (form.elements[e].type != 'hidden' && 
        form.elements[e].disabled != true)
      break;
  }
  return form.elements[e % form.elements.length];
}


function disableTextField (field) {
  if (document.all || document.getElementById) 
    field.disabled = true;
  else {
    field.oldOnFocus = field.onfocus;
    field.onfocus = skip;
  }
}


function enableTextField (field) {
  if (document.all || document.getElementById)
    field.disabled = false;
  else {
    field.onfocus = field.oldOnFocus;
  }
}



// ----------------------------------------------------------------------
//  OpenLink specific functions
// ----------------------------------------------------------------------

function opl_ValidDSN(thisform) {
  if (thisform.Name.value == "") {
    alert ('You must enter a DSN name');
    return false;
  }

  return true;
}


function opl_EnableEnv(thisform) {
  if (thisform.EnvNameNew.value == "") {
    enableTextField (thisform.ServerType);
  } else {
    disableTextField (thisform.ServerType);
  }
}


function testdsn() {
  i = document.dsnlist.dsn.selectedIndex;
  if (i > 0) {
    return true;
  } else {
    alert("Select a DSN to test");
  return false;
  }
}


function opl_set_state(me, field) {
   if(me.checked) { 
     enableTextField (field);
   } else { 
     disableTextField (field);
   }
}



// ----------------------------------------------------------------------
//  Window manipulation
// ----------------------------------------------------------------------

//  Open a wizard window
function WinOpen(wURL, wName, wWidth, wHeight) {
  return window.open(wURL,wName,
    "toolbar=no,location=no,directories=no,status=no,menubar=no," + 
    "scrollbars=0,resizable=1,width=" + wWidth + ",height=" + wHeight)
}


// Set viewfr frame to about window
function reset_viewfr() {
  parent.frames['viewfr'].location = 'about.html';
}



// Start Data Sources window
function start_wods() {
  WinOpen ('/scripts/wods', 'wods', 580, 400);
  reset_viewfr();
}


// Refresh Data Sources window
function refresh_wods(dsn) {
  url = "/scripts/wods";
  if (dsn > "")
    url = url + "?dsn=" + dsn;
  WinOpen (url, 'wods', 580, 400);
}


// Start Data Source wizard page
function start_aods(cmd) {
  if (cmd=="add") {
    hwndAds = WinOpen("aods/"+cmd, "aods", "580", "320");
  } else {
    i = document.dsnlist.dsn.selectedIndex;
    if (i >= 0) {
      dsn=document.dsnlist.dsn.options[i].value;
      hwndAds = WinOpen("aods/"+cmd+"?dsn="+dsn, "aods", "580", "320");
    } else {
      alert("You must select a DSN");
    }
  }
}


// Start Server Type window
function start_wost() {
  WinOpen ('/scripts/wost', 'wods', 580, 400);
  reset_viewfr();
}


// Refresh Server Type window
function refresh_wost(svt) {
  url = "/scripts/wost";
  if (svt > "")
    url = url + "?svt=" + svt;

  WinOpen (url, 'wods', 580, 400);
}



// Start Server Type wizard
function start_aost(cmd) {
  if (cmd=="add") {
    hwndAds = WinOpen("aost/"+cmd, "aost", "580", "320");
  } else {
    i = document.stlist.stypes.selectedIndex;
    if (i >= 0) {
      svt=document.stlist.stypes.options[i].value;
      hwndAds = WinOpen("aost/"+cmd+"?svt="+svt, "aost", "580", "320");
    } else {
      alert("You must select a Server Type");
    }
  }
}


//  Start broker wizard
function start_bsu() {
  WinOpen ('/scripts/bsu', 'bsu', 530, 330);
  reset_viewfr();
}


//  Start Zero Config window
function start_wozc() {
  WinOpen ('/scripts/wozc', 'wozc', 580, 400);
  reset_viewfr();
}

// Refresh Zero Config window
function refresh_wozc(dsn, reinit) {
  url = "/scripts/wozc?";
  if (dsn > "")
    url = url + "&dsn=" + dsn;

  if (reinit)
    url = url + "&reinit=1";

  WinOpen (url, 'wozc', 580, 400);
}


//  Start Zero Config Wizard
function start_aozc(cmd) {
  if (cmd=="add") {
    hwndAds = WinOpen("aozc/"+cmd, "aozc", "580", "320");
  } else {
    i = document.zerolist.dsn.selectedIndex;
    if (i >= 0) {
      dsn=document.zerolist.dsn.options[i].value;
      hwndAds = WinOpen("aozc/"+cmd+"?dsn="+dsn, "aozc", "580", "320");
    } else {
      alert("You must select an entry");
    }
  }
}


// Start OpenLink Debugging window
function start_wod() {
  WinOpen ('/scripts/wod', 'wods', 580, 400);
  reset_viewfr();
}


// Start OpenLink Client Communications window
function start_woco() {
  WinOpen ('/scripts/woco', 'wods', 580, 400);
  reset_viewfr();
}



function WizardOnLoad()
{
  var imgX; 
  var imgY;
  var found = 0;
  var myWidth = 0, myHeight = 0;

  //  Find out size of current window
  if( typeof( window.innerWidth ) == 'number' ) {
    //Non-IE
    myWidth = window.innerWidth;
    myHeight = window.innerHeight;
  } else {
    if( document.documentElement &&
        ( document.documentElement.clientWidth || document.documentElement.clientHeight ) ) {
      //IE 6+ in 'standards compliant mode'
      myWidth = document.documentElement.clientWidth;
      myHeight = document.documentElement.clientHeight;
    } else {
      if( document.body && ( document.body.clientWidth || document.body.clientHeight ) ) {
        //IE 4 compatible
        myWidth = document.body.clientWidth;
        myHeight = document.body.clientHeight;
      }
    }
  }

  //  Find the image
  for (var l = 0; l < document.images.length; l++)
    if (found = 'botright' == document.images[l].name)
      break;

  if (found) {
    //  Calculate the position of the image
    if (document.layers) {		// NS 4
      weight = 10;			
      imgX = document.images[l].y;
      imgY = document.images[l].x;
    } else {				//  Modern browsers
      weight = 10;		
      imgX = getRealTop (document.images[l]);
      imgY = getRealLeft (document.images[l]);
    }

    // Chanage the width
    if (imgY > myWidth)  {
      window.resizeBy (weight + imgY - myWidth, 0);
    }

    // Change the height
    if (imgX > myHeight)  {
      window.resizeBy (0, weight + imgX - myHeight);
    }
  }

  //  Set the focus to the first element of the form
  window.focus();
  getFirstField(document.forms[0]).focus();
}


//  Close a registered wizard (sub)window
var hwndAds = null;

function WizardOnUnload() {
  if(hwndAds && !hwndAds.closed)
    if(hwndAds.name=="add_ods")
      hwndAds.close();
  hwndAds = null;
}


//
//  Netscape 4.7x resize bug workaround
//
if (document.layers) {
  origWidth = innerWidth;
  origHeight = innerHeight;
  onresize = function () {
    if(innerWidth != origWidth || innerHeight != origHeight)
      location.reload()
  }
}
