#
#  auth.tcl
#
#  $Id: auth.tcl,v 1.2 1998/07/17 12:59:15 source Exp $
#
#  Check host and user access
#
#  (C)Copyright 1997 OpenLink Software.
#  All Rights Reserved.
#
#  The copyright above and this notice must be preserved in all
#  copies of this source code.  The copyright above does not
#  evidence any actual or intended publication of this source code.
#
#  This is unpublished proprietary trade secret of OpenLink Software.
#  This source code may not be copied, disclosed, distributed, demonstrated
#  or licensed except as authorized by OpenLink Software.
#

set DB users.dat

set USER ""
set ACCLVL 0
set INSECURE 0

proc check_auth {level} {
    global DB USER ACCLVL INSECURE
    set user [req auth_user]

    if {$USER == ""} {
	master www_sv refresh

	if {![check_host_access]} {
	    # TITLE OpenLink Web Configurator
	    HEAD Access Denied
	    return 0
	}
	if {[master www_sv keys Users] == ""} {
	    # empty db - no auth
	    set $ACCLVL 3
	    set $USER $user
	    set INSECURE 1
	    return 1
	}
	set INSECURE 0
	set entry [master www_sv read Users $user ""]
	if {[req auth_type] != "Basic" || $user == "" || $entry != "1"} {
	    needauth
	    return 0
	}
	if {[cryptpw [req auth_pw]] != [master www_sv read "User $user" Password ""]} {
	    needauth
	    return 0
	}
	set USER $user
	set ACCLVL [master www_sv read "User $user" Level 0]
	if {$ACCLVL == 0} {
	    # access level 0 - deny access
	    needauth
	    return 0
	}
    }
    if {$level && $ACCLVL < $level} {
	# TITLE OpenLink Web Configurator
	HEAD Access is denied
	SECTION Insufficient privileges for this operation.
	if {$level == 1} {
	    html You must have read privileges to access this information.<p>
	} elseif {$level == 2} {
	    html You must have update privileges to modify this information.<p>
	} else {
	    html You must have administrator privileges for this operation.<p>
	}
	main_button
	return 0;
    }
    return 1
}

proc check_host_access {} {
    set keys [master www_sv keys Hosts]

    # no [Hosts] sections means allow everyone
    if {$keys == ""} {
	return 1
    }

    foreach key $keys {
	set value [master www_sv read Hosts $key ""]
	if {[string match $key [req from_ip]]} {
	    if {$value == "allow"} {
		return 1
	    }
	    return 0
	}
    }
    return 0
}
