#
#  dsntest.tcl
#
#  $Id: dsntest.tcl,v 1.7 2003/03/28 10:25:47 source Exp $
#
#  ODBC/UDBC test routines
#
#  (C)Copyright 1998 OpenLink Software.
#  All Rights Reserved.
#
#  The copyright above and this notice must be preserved in all
#  copies of this source code.  The copyright above does not
#  evidence any actual or intended publication of this source code.
#
#  This is unpublished proprietary trade secret of OpenLink Software.
#  This source code may not be copied, disclosed, distributed, demonstrated
#  or licensed except as authorized by OpenLink Software.
#

#
# Show Input form for UID and PWD
# dbc="ODBC" or "UDBC"
#
proc DSNTestPrompt {dbc dsn uid} {
    DSNTestPrompt2 $dbc $dsn $uid [req uri]
}

proc DSNTestPrompt2 {dbc dsn uid act} {
    set dsn [unescape $dsn]
    html "<head><title>$dbc Test</title></head>\n"
    html "<body bgcolor=#C0C0C0 text=#000000 onload='self.focus()'>\n<FORM METHOD=POST ACTION=$act>\n"
    html "<table border=0>\n"
    html "<tr><td align=center colspan=2><font size=6><strong>Test $dbc</strong></font></td></tr>\n"
    html "<tr><td><b>DSN&nbsp;Name:</b></td><td><input type=text name=dsn size=20 value=\""
    html -escape $dsn
    html "\"></td></tr>\n"
    html "<tr><td><b>User&nbsp;ID:</b></td><td><input type=text name=uid size=20 value=\""
    html -escape $uid
    html "\"></td></tr>\n"
    html "<tr><td><b>Password:</b></td><td><input type=password name=pwd size=20></td></tr>\n"
    html "<tr><td align=center colspan=2><br>\n"
    html "<INPUT TYPE=hidden name=dbc value=\"$dbc\">\n"
    html {<SCRIPT Language="JavaScript">
document.write("<INPUT TYPE=hidden name=havejs value=true>")
</SCRIPT>
}
    html "<INPUT TYPE=submit name=test value=\"  Test  \">&nbsp;&nbsp;&nbsp;\n"
    html "<INPUT TYPE=reset value=\" Reset \">&nbsp;&nbsp;&nbsp;\n"
    html "<INPUT TYPE=submit name=cancel value=\" Cancel \">\n"
    html "</td></tr>\n</table>\n</body>\n</html>\n"
}

#
# For TCL-DB supported test, make test and place results in alert box
# For non supported type, make the popup launch the external testcon.
#
proc DSNTest {} {
    set dbc [var dbc]
    set dsn [unescape [var dsn]]
    set uid [var uid]
    set pwd [var pwd]
    html "function testresult() {\n"
    if {[GetDBC]==$dbc} {
	if {[catch {
	    database connect db $dsn $uid $pwd
	    db close
	} err ]} {
	    set err [join [split $err "\n"] "\\n"]
	    set err [join [split $err "\""] "\\\""]
	    html "  alert(\"Connect Failed\\n$err\");\n"
	} else {
	    html "  alert(\"Connected OK\");\n"
	}
    } else {
        # There could be spaces in here
	set dsn [escape [var dsn]]

	# convert ODBC to o and UDBC to u
	set dbc [string tolower [string range $dbc 0 0]]
	set testurl "'/cgi-bin/testcon$dbc?dsn=$dsn;uid=$uid;pwd=$pwd;prompt='"
	html "  window.open($testurl,'testcon$dbc','toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=510,height=270');\n"
    }
    html "}\n"
}

proc unescape {n} {
    while {[regexp {(.*)%([0-9a-fA-F][0-9a-fA-F])(.*)} $n full left hex right]} {
	set n $left[format "%c" 0x$hex]$right
    }
    return $n
}

proc dsnfail {reason} {
    html <html><body>
    html <center><H2>Error</H2>
    html <H3>$reason</H3>
    html {<form><input type="button" name="exit" value="Exit" onclick="self.close()"></form></center></body></html>}
}
