#
#  mrdefh.tcl
#
#  $Id: mrdefh.tcl,v 1.1 1997/12/12 15:04:08 paul Exp $
#
#  Subroutine to modify the default handler mapping rules
#
#  (C)Copyright 1997 OpenLink Software.
#  All Rights Reserved.
#
#  The copyright above and this notice must be preserved in all
#  copies of this source code.  The copyright above does not
#  evidence any actual or intended publication of this source code.
#
#  This is unpublished proprietary trade secret of OpenLink Software.
#  This source code may not be copied, disclosed, distributed, demonstrated
#  or licensed except as authorized by OpenLink Software.
#

proc setDefaultHandler {domain action arg} {

    set rules [master getMappingRules]

    # Build two lists:
    #  newRules - all mapping rules not containing domain
    #  dmnRules - all mapping rules containing domain, or with wildcard in dom.
    set newRules {}
    set dmnRules {}
    foreach rule $rules {
	set tgt [lindex $rule 0]
	if {$tgt == "*"} {
	    lappend dmnRules [lreplace $rule 0 0 $domain]
	    lappend newRules $rule
	} elseif {$tgt == $domain} {
	    lappend dmnRules $rule
	} else {
	    lappend newRules $rule
	}
    }

    # Now replace the default handler if any
    set tmpRules {}
    set handled 0
    foreach rule $dmnRules {
	set str [join [lrange $rule 1 6] :]
	if {$str == "*:*:*:*:*:*"} {
	    lappend tmpRules [lreplace $rule 7 8 $action $arg]
	    set handled 1
	} else {
	    lappend tmpRules $rule
	}
    }

    # Make one set again
    set dmnRules {}
    if {!$handled} {
	lappend dmnRules [list $domain * * * * * * $action $arg]
    }
    foreach rule $tmpRules {
	lappend dmnRules $rule
    }
    foreach rule $newRules {
	lappend dmnRules $rule
    }

    # Remove old mapping rules
    master rulebook write "Mapping Rules"

    # Write the new set
    foreach rule $dmnRules {
	master rulebook write "Mapping Rules" [join [lrange $rule 0 6] :] \
	    "[lindex $rule 7] [lindex $rule 8]"
    }

    master rulebook commit
    master set mappingRules $dmnRules
}
